using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Mythos._0_Modelos;
using System.Transactions;
using System.Data.SqlClient;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Mythos._1_Datos
{
    public class MYT_PlanMantenimientosLineas_Protocolos_Datos : ABS_Datos
    {

        #region Listado
        
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }

        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {}
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }

        #endregion
        #region F3

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }

        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }


        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
        }
        #endregion

        #region Obtener
        public override dynamic Obtener(long _lng_id)
        {
            return null;
        }

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private MYT_PlanMantenimientosLineas_Protocolos g_mdl_MYT_ProtocolosRespuestas = null;
        public MYT_PlanMantenimientosLineas_Protocolos Obtener_Modelo_Por_Ids(long _lng_idPlanMantenimientoLinea, long _lng_idProtocolo)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 " WHERE " +
                                 nameof(MYT_PlanMantenimientosLineas_Protocolos) + "." + nameof(MYT_PlanMantenimientosLineas_Protocolos.idPlanMantenimientoLinea) + "=@idPlanMantenimientoLinea and " +
                                 nameof(MYT_PlanMantenimientosLineas_Protocolos) + "." + nameof(MYT_PlanMantenimientosLineas_Protocolos.idProtocolo) + "=@idProtocolo";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idPlanMantenimientoLinea",  _lng_idPlanMantenimientoLinea),
                     new SqlParameter("@idProtocolo",  _lng_idProtocolo)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PlanMantenimientosLineas_Protocolos_Datos) + "/" + nameof(Obtener_Modelo_Por_Ids), true);
            }

            return g_mdl_MYT_ProtocolosRespuestas;
        }
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MYT_ProtocolosRespuestas = obj_Exferia_Entities.Database.SqlQuery<MYT_PlanMantenimientosLineas_Protocolos>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PlanMantenimientosLineas_Protocolos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<MYT_PlanMantenimientosLineas_Protocolos> g_lst_MYT_PlanMantenimientosLineas_Protocolos = null;

        public List<MYT_PlanMantenimientosLineas_Protocolos> Obtener_ModeloListado_Por_IdsPlanMantenimientoLinea(List<long> _lst_idPlanMantenimientoLinea)
        {
            try
            {
                g_lst_MYT_PlanMantenimientosLineas_Protocolos = null;

                if (_lst_idPlanMantenimientoLinea != null && _lst_idPlanMantenimientoLinea.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(MYT_PlanMantenimientosLineas_Protocolos),
                                                                                             nameof(MYT_PlanMantenimientosLineas_Protocolos.idPlanMantenimientoLinea),
                                                                                             G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                             _lst_idPlanMantenimientoLinea);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    str_Filtro_IDS;


                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                        new object[] { });


                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PlanMantenimientosLineas_Protocolos_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdsPlanMantenimientoLinea), true);
            }

            return g_lst_MYT_PlanMantenimientosLineas_Protocolos;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el modelo
                g_lst_MYT_PlanMantenimientosLineas_Protocolos = obj_Exferia_Entities.Database.SqlQuery<MYT_PlanMantenimientosLineas_Protocolos>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PlanMantenimientosLineas_Protocolos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(MYT_PlanMantenimientosLineas_Protocolos.idPlanMantenimientoLinea) + " , " +
                   nameof(MYT_PlanMantenimientosLineas_Protocolos.idProtocolo) + " , " +
                   nameof(MYT_PlanMantenimientosLineas_Protocolos.observaciones) +
               " FROM " + nameof(MYT_PlanMantenimientosLineas_Protocolos);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MYT_PlanMantenimientosLineas_Protocolos mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar = (MYT_PlanMantenimientosLineas_Protocolos)_mdl_obj;
                MYT_PlanMantenimientosLineas_Protocolos mdl_MYT_PlanMantenimientosLineas_Protocolos_DatosViejos = new MYT_PlanMantenimientosLineas_Protocolos();

                // Ver si existe ###################################################################### 
                MYT_PlanMantenimientosLineas_Protocolos mdl_MYT_PlanMantenimientosLineas_Protocolos_Final = Obtener_Modelo_Por_Ids(mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar.idPlanMantenimientoLinea, mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar.idProtocolo);
                //######################################################################################

                //UPDATE
                if (mdl_MYT_PlanMantenimientosLineas_Protocolos_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_PlanMantenimientosLineas_Protocolos_Final, mdl_MYT_PlanMantenimientosLineas_Protocolos_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar, mdl_MYT_PlanMantenimientosLineas_Protocolos_Final, false, false);

                    #region update
                    string str_SQL_Update = " UPDATE " + nameof(MYT_PlanMantenimientosLineas_Protocolos) +
                                           " SET " +
                                               nameof(MYT_PlanMantenimientosLineas_Protocolos.observaciones) + "=@observaciones " +
                                           " WHERE " +
                                               nameof(MYT_PlanMantenimientosLineas_Protocolos.idPlanMantenimientoLinea) + "=@idPlanMantenimientoLinea and " +
                                               nameof(MYT_PlanMantenimientosLineas_Protocolos.idProtocolo) + "=@idProtocolo";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar.observaciones!=null
                            ?   new SqlParameter("@observaciones", mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                        new SqlParameter("@idPlanMantenimientoLinea",  mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar.idPlanMantenimientoLinea),
                        new SqlParameter("@idProtocolo",  mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar.idProtocolo)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);
                }
                //INSERT
                else
                {
                    mdl_MYT_PlanMantenimientosLineas_Protocolos_Final = new MYT_PlanMantenimientosLineas_Protocolos();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar, mdl_MYT_PlanMantenimientosLineas_Protocolos_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MYT_PlanMantenimientosLineas_Protocolos) +
                                               " (" +
                                                       nameof(MYT_PlanMantenimientosLineas_Protocolos.idPlanMantenimientoLinea) + "," +
                                                       nameof(MYT_PlanMantenimientosLineas_Protocolos.idProtocolo) + "," +
                                                       nameof(MYT_PlanMantenimientosLineas_Protocolos.observaciones) +
                                               " ) " +
                                               " VALUES " +
                                               " ( " +
                                                   "@idPlanMantenimientoLinea," +
                                                   "@idProtocolo," +
                                                   "@observaciones" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idPlanMantenimientoLinea",  mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar.idPlanMantenimientoLinea),
                        new SqlParameter("@idProtocolo",  mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar.idProtocolo),
                        mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar.observaciones!=null
                            ?   new SqlParameter("@observaciones", mdl_MYT_PlanMantenimientosLineas_Protocolos_AGrabar.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value)

                    };
                    #endregion

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Insert, arr_Parametros_Insert);
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MYT_PlanMantenimientosLineas_Protocolos), mdl_MYT_PlanMantenimientosLineas_Protocolos_DatosViejos, mdl_MYT_PlanMantenimientosLineas_Protocolos_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PlanMantenimientosLineas_Protocolos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            return null;
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Delete
                string str_SQL_Delete = " DELETE FROM " + nameof(MYT_PlanMantenimientosLineas_Protocolos) +
                                        " WHERE " +
                                            nameof(MYT_PlanMantenimientosLineas_Protocolos.idPlanMantenimientoLinea) + "=@idPlanMantenimientoLinea AND " +
                                            nameof(MYT_PlanMantenimientosLineas_Protocolos.idProtocolo) + "=@idProtocolo";

                //Parametros
                object[] arr_Parametros_Delete = new object[]
                {
                    new SqlParameter("@idPlanMantenimientoLinea",  _lng_id),
                    new SqlParameter("@idProtocolo", _lng_idAuxiliar)
                };
                #endregion

                //Delete
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PlanMantenimientosLineas_Protocolos_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }

        public INTERNO_ValorDevuelto_Modelo Borrar_Por_IdPlanMantenimientoLinea(long _lng_idPlanMantenimientoLinea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Delete
                string str_SQL_Delete = " DELETE FROM " + nameof(MYT_PlanMantenimientosLineas_Protocolos) +
                                        " WHERE " +
                                            nameof(MYT_PlanMantenimientosLineas_Protocolos.idPlanMantenimientoLinea) + "=@idPlanMantenimientoLinea ";

                //Parametros
                object[] arr_Parametros_Delete = new object[]
                {
                    new SqlParameter("@idPlanMantenimientoLinea",  _lng_idPlanMantenimientoLinea)
                };
                #endregion

                //Delete
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PlanMantenimientosLineas_Protocolos_Datos) + "/" + nameof(Borrar_Por_IdPlanMantenimientoLinea), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
